#!/usr/bin/perl
 
#*******************************************
#Quirky Wisconsin Ecards - Colleen Koranda
#CS 460 - Senior Capstone Experience
#St. Norbert College
#Perl
#May 2, 2005
#*******************************************
#savejpg.pl: parses ecard paramters: background
#image, wave option, date, and .jpg.  It
#generates the ecard ID, saves ID.jpg and
#ID.txt.  HTML is generated to load
#ecard_send.swf and passes the ID
#*******************************************
 
#*******************************************
#Function hex_to_ascii($)
#Purpose: converts string from ascii to hex,
#used for soi and eoi for .jpg
#*******************************************
sub hex_to_ascii($)
{
 (my $str=shift) =~s/([a-fA-F0-9]{2})/chr(hex $1)/eg;
 return $str;
}
 
require "sublog.lib";  #activity log
 
#Get the data values from the form variables into '$q'
 
$met = $ENV{'REQUEST_METHOD'};
if ($met eq "GET") {
   $q = $ENV{'QUERY_STRING'};
}
else { # "POST"
  read(STDIN, $q, $ENV{'CONTENT_LENGTH'});
}
 
 
print "Content-type: text/html\n\n";
 
#*******parse variables*******#
($temp1,$temp2) = split(/="udate"\s/,$q);
($udate,$temp2) = split(/\s-/,$temp2,2);
 
#remove whitespace char at end of date
chop($udate);
$udate1 = substr($udate,3,scalar($udate));
 
($junk,$var) = split(/bk=/,$temp2);
($bk,$q) = split(/\s\S/,$var,2);
 
#remove whitespace char at the end of bk
chop($bk);
 
 
#*******generate id*******#
#dollar-dollar is unique transaction id
$id=$$ . "-" . $udate1;
 
 
#convert header hex to ascii
$ff = hex_to_ascii FF;
$de = hex_to_ascii D8;
$dn = hex_to_ascii D9;
 
#concat ascii
#jpg start of image (soi) = 0xff 0xd8
#jpg end of image (eoi) = 0xff 0xd9
$soi = $ff . $de;
$eoi = $ff . $dn;
 
 
#parse html header for .jpg based on soi
#2 is the max # substrings produced
@temp=split(/$soi/,$q,2);
 
#parse html footer based on eoi
@temp2=split(/$eoi$/,$temp[1],2);
 
 
#save image to file with soi and eoi
$fname="./$id".".jpg";
open(OUT, ">$fname") or &ErrorMessage;
print OUT "$soi";
print OUT "$temp2[0]";
print OUT "$eoi";
close(OUT);
 
#save to log.txt
&Log(" $id.jpg saved");
 
#save background info to id.txt
$newfile="./$id".".txt";
open(OUT2, ">$newfile") or &ErrorMessage;
print OUT2 "bk=$bk&";
close(OUT2);
 
#generate html to load flash
print<<tag1;
 
<HTML>
<HEAD><TITLE>Title</TITLE></HEAD>
<BODY bgcolor="#000000" topmargin="0" leftmargin="0">
 
<center>
 
<object width="780" height="425">
<param name="movie" value="ecard_send.swf">
<embed src="ecard_send.swf?file=$id&bk=$bk" width="780" height="425">
</embed>
</object>
 
</center>
 
<SCRIPT LANGUAGE="JAVASCRIPT">
  function error(str){
  alert(str);
  }
</SCRIPT>
 
 
</BODY>
</HTML>
tag1
 
print "ID=$id";  #hide ID below flash
 
 
#*******************************************
#Function ErrorMessage
#Purpose: display/record error message
#*******************************************
sub ErrorMessage{
 &Log(" $id error saving $id.jpg");
 print "<BR>Error uploading image, please try again<BR>";
 exit;
}
